------------------------------------------------------------------------------
--                                                                          --
--                            Matreshka Project                             --
--                                                                          --
--                          Ada Modeling Framework                          --
--                                                                          --
--                        Runtime Library Component                         --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2012, Vadim Godunko <vgodunko@gmail.com>                     --
-- All rights reserved.                                                     --
--                                                                          --
-- Redistribution and use in source and binary forms, with or without       --
-- modification, are permitted provided that the following conditions       --
-- are met:                                                                 --
--                                                                          --
--  * Redistributions of source code must retain the above copyright        --
--    notice, this list of conditions and the following disclaimer.         --
--                                                                          --
--  * Redistributions in binary form must reproduce the above copyright     --
--    notice, this list of conditions and the following disclaimer in the   --
--    documentation and/or other materials provided with the distribution.  --
--                                                                          --
--  * Neither the name of the Vadim Godunko, IE nor the names of its        --
--    contributors may be used to endorse or promote products derived from  --
--    this software without specific prior written permission.              --
--                                                                          --
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS      --
-- "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT        --
-- LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    --
-- A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     --
-- HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
-- SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED --
-- TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   --
-- PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF   --
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING     --
-- NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS       --
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.             --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2807 $ $Date: 2012-04-07 01:28:23 +0400 (Sat, 07 Apr 2012) $
------------------------------------------------------------------------------
--  This file is generated, don't edit it.
------------------------------------------------------------------------------
with AMF.Internals.Utp_Elements;
with AMF.UML.Elements;
with AMF.Utp.Managed_Elements;
with AMF.Visitors;

package AMF.Internals.Utp_Managed_Elements is

   type Utp_Managed_Element_Proxy is
     limited new AMF.Internals.Utp_Elements.Utp_Element_Proxy
       and AMF.Utp.Managed_Elements.Utp_Managed_Element with null record;

   overriding function Get_Base_Element
    (Self : not null access constant Utp_Managed_Element_Proxy)
       return AMF.UML.Elements.UML_Element_Access;
   --  Getter of ManagedElement::base_Element.
   --

   overriding procedure Set_Base_Element
    (Self : not null access Utp_Managed_Element_Proxy;
     To   : AMF.UML.Elements.UML_Element_Access);
   --  Setter of ManagedElement::base_Element.
   --

   overriding function Get_Owner
    (Self : not null access constant Utp_Managed_Element_Proxy)
       return AMF.Optional_String;
   --  Getter of ManagedElement::owner.
   --

   overriding procedure Set_Owner
    (Self : not null access Utp_Managed_Element_Proxy;
     To   : AMF.Optional_String);
   --  Setter of ManagedElement::owner.
   --

   overriding function Get_Description
    (Self : not null access constant Utp_Managed_Element_Proxy)
       return AMF.Optional_String;
   --  Getter of ManagedElement::description.
   --

   overriding procedure Set_Description
    (Self : not null access Utp_Managed_Element_Proxy;
     To   : AMF.Optional_String);
   --  Setter of ManagedElement::description.
   --

   overriding function Get_Version
    (Self : not null access constant Utp_Managed_Element_Proxy)
       return AMF.Optional_String;
   --  Getter of ManagedElement::version.
   --

   overriding procedure Set_Version
    (Self : not null access Utp_Managed_Element_Proxy;
     To   : AMF.Optional_String);
   --  Setter of ManagedElement::version.
   --

   overriding function Get_Criticality
    (Self : not null access constant Utp_Managed_Element_Proxy)
       return AMF.Optional_String;
   --  Getter of ManagedElement::criticality.
   --

   overriding procedure Set_Criticality
    (Self : not null access Utp_Managed_Element_Proxy;
     To   : AMF.Optional_String);
   --  Setter of ManagedElement::criticality.
   --

   overriding procedure Enter_Element
    (Self    : not null access constant Utp_Managed_Element_Proxy;
     Visitor : in out AMF.Visitors.Abstract_Visitor'Class;
     Control : in out AMF.Visitors.Traverse_Control);

   overriding procedure Leave_Element
    (Self    : not null access constant Utp_Managed_Element_Proxy;
     Visitor : in out AMF.Visitors.Abstract_Visitor'Class;
     Control : in out AMF.Visitors.Traverse_Control);

   overriding procedure Visit_Element
    (Self     : not null access constant Utp_Managed_Element_Proxy;
     Iterator : in out AMF.Visitors.Abstract_Iterator'Class;
     Visitor  : in out AMF.Visitors.Abstract_Visitor'Class;
     Control  : in out AMF.Visitors.Traverse_Control);

end AMF.Internals.Utp_Managed_Elements;
